Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 31)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 32)
@@ -87,5 +87,5 @@
 			}
 			
-			protected function initChart() : void
+			protected function initChart(event : ResultEvent) : void
 			{
 				Alert.show("initChart");
@@ -134,5 +134,5 @@
 				
 				var data : ArrayCollection = parentApplication.gsSimStudioModel.ganntChartComponents['' + expId].allocationList;
-				Alert.show("getRowsData");
+				
 				startDate = new Date(3000);
 				endDate = new Date(0);
@@ -141,8 +141,6 @@
 				tempRowDataProvider = new ArrayCollection();
 				var resMap : Object = new Object();
-				Alert.show("iterate!");
 				for( var i : Number = 0; i < data.length; i++ )
 				{
-					Alert.show("check in dictionary " + i);
 					if (!resMap.hasOwnProperty(data[i].unitId))
 					{
@@ -153,8 +151,6 @@
 					var dummycolor : uint = 0x999999 + randomInt( 0x777777 );
 					
-					Alert.show("add schedule entry " + i);
 					resMap[data[i].unitId].addItem(createColoredEntry(data[i].taskId, data[i].begin, data[i].end, dummycolor, 1,0,1));
 					
-					Alert.show("set begin/end " + i);
 					if (data[i].begin < startDate) startDate = data[i].begin;
 					if (data[i].end > endDate) endDate = data[i].end;
@@ -325,5 +321,4 @@
 		<mx:HBox>
 			<mx:Button label="PNG" click="saveAsPNG();"/>
-			<mx:Button label="do it!" click="initChart();"/>
 		</mx:HBox>
 		<mx:VBox width="100%" height="100%" verticalGap="1" id="fullChart">
@@ -357,5 +352,5 @@
 											entryRenderer="flexlib.scheduling.scheduleClasses.renderers.ColoredSolidScheduleEntryRenderer"
 											horizontalLinesViewer="flexlib.scheduling.samples.AlternatingHorizontalLinesViewer"
-											horizontalScrollPolicy="off" itemScroll="scrollList( event )"
+											itemScroll="scrollList( event )"
 											pixelScroll="onScrollScheduleViewer( event )"
 											pixelScrollEnabled="false" startDate="{ startDate }"
@@ -389,50 +384,4 @@
 						</s:HGroup>
 					</s:HGroup>
-					<s:Group>
-						<s:Rect width="100%" height="100%">
-							<s:stroke>
-								<s:SolidColorStroke color="0x999999" weight="1"/>
-							</s:stroke>
-						</s:Rect>
-						<!--
-						<s:HGroup width="{ scheduleViewerWidth }" left="10" top="10" right="10" bottom="10">
-							
-							<s:Label text="Goto:" top="5"/>
-							<s:Button label="Now" click="gotoNow();"/>
-							<s:Button label="Selected" click="gotoSelectedEntry();"/>
-							<s:Rect width="100%"/>
-							<s:Button label="Matrix" click="openMatrix()"/>
-							<s:Label text="History (days):" top="5"/>
-							<s:TextInput id="srcHistory" width="25" text="2"/>
-							<s:Button label="Apply"
-									  click="historyLength = int(srcHistory.text); onReservationsReady();"/>
-						</s:HGroup>
-						-->
-					</s:Group>
-					<s:Group>
-						<s:Rect width="100%" height="100%">
-							<s:stroke>
-								<s:SolidColorStroke color="0x999999" weight="1"/>
-							</s:stroke>
-						</s:Rect>
-						<!--
-						<s:HGroup width="{ scheduleViewerWidth }" left="10" top="10" right="10" bottom="10">
-							<s:Label text="Show:" top="15"/>
-							
-							<s:RadioButton id="onlyJob" label="Only Reservations" groupName="groupByType" selected="true"
-										   value="onlyJob"/>
-							<s:RadioButton id="onlyTask" label="Only Tasks" groupName="groupByType" value="onlyTask"/>
-							<s:RadioButton id="both" label="Reservations and Tasks" groupName="groupByType"
-										   value="both"/>
-							<s:Rect width="33%" height="1"/>
-							<s:Label text="Group by:" top="5"/>
-							
-							<s:RadioButton id="Job" label="Job" groupName="groupByRBG" selected="true" value="Job"/>
-							<s:RadioButton id="Task" label="Task" groupName="groupByRBG" value="Task"/>
-							<s:RadioButton id="ProcessGroup" label="Process Group" groupName="groupByRBG"
-										   value="ProcessGroup"/>
-						</s:HGroup>
-						-->
-					</s:Group>
 					
 				</s:VGroup>