Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 27)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/gssim/editors/archive/ExperimentStatisticsWindow.mxml	(revision 37)
@@ -6,5 +6,5 @@
 		   title="{experiment.name} - {resourceManager.getString('ArchiveViewer', 'Details')}"
 		   xmlns:fx="http://ns.adobe.com/mxml/2009" 
-		   width="600" height="400"
+		   width="600" height="450"
 		   xmlns:charts="gssim.gssimstudio.editor.charts.*"
 		   xmlns:archive="gssim.gssimstudio.editor.gssim.editors.archive.*"
@@ -47,9 +47,10 @@
 			//parentApplication.bindSubmodel(viewer, 'model', parentApplication.gsSimStudioModel, 'resourceChartComponents', '' + i);
 			
-			var gannt : GanntChart = new GanntChart();
+			//var gannt : GanntChart = new GanntChart();
 			gannt.expId = i;
 			gannt.expName = (experiment != null ? experiment.name : "");
 			gannt.service = new VineRemoteObjectProxy(parentApplication.service, i);
-			ganntChart.addChild(gannt);
+			gannt.init();
+			//ganntChart.addChild(gannt);
 		}
 		
@@ -124,4 +125,5 @@
 			</mx:VBox>
 			<mx:VBox width="100%" height="100%" id="ganntChart" label="{resourceManager.getString('ArchiveViewer', 'Task')}">
+				<charts:GanntChart scheduleViewerHeight="{this.height - 250}" scheduleViewerWidth="{this.width - 250}" id="gannt" />
 			</mx:VBox>
 			<!--
Index: gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml
===================================================================
--- gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 36)
+++ gssim_ui/branches/vine/gssimstudio/src/web/ui/flex/app/gssim/gssimstudio/editor/charts/GanntChart.mxml	(revision 37)
@@ -6,5 +6,5 @@
 	xmlns:c="gssim.gssimstudio.editor.charts.components.*"
 	xmlns:fx="http://ns.adobe.com/mxml/2009"  
-	width="100%" creationComplete="init()"
+	width="100%"
 	height="100%" xmlns:charts="com.iwobanas.charts.*" xmlns:data="gssim.gssimstudio.editor.charting.data.*" xmlns:charts1="gssim.gssimstudio.editor.charts.*" xmlns:code="http://code.google.com/p/flexlib/" 
 >
@@ -53,7 +53,7 @@
 			private var zoom : Number;
 			[Bindable]
-			private var scheduleViewerWidth : Number = 635;
-			[Bindable]
-			private var scheduleViewerHeight : Number = 4*50;
+			public var scheduleViewerWidth : Number = 635;
+			[Bindable]
+			public var scheduleViewerHeight : Number = 4*50;
 			[Bindable]
 			private var dataProvider : IList;
@@ -83,11 +83,14 @@
 			{
 				date = new Date();
+				vZoomSliderGroup.visible = false;
+				hZoomSliderGroup.visible = false;
 				var k : SaveToPNGCommand = new SaveToPNGCommand(fullChart);
 				k.execute();
+				vZoomSliderGroup.visible = true;
+				hZoomSliderGroup.visible = true;
 			}
 			
 			protected function initChart(event : ResultEvent) : void
 			{
-				Alert.show("initChart");
 				initDataProvider();
 				vZoom = 50;
@@ -100,5 +103,44 @@
 			protected function initFake() : void
 			{
-				Alert.show("fake!");
+				dataProvider = new ArrayCollection();
+				
+				var data : ArrayCollection = new ArrayCollection();
+				data.addItem({unitId : 50, taskId : 1000, begin : new Date(2008, 4, 3), end : new Date(2008, 4, 10)});
+				
+				startDate = new Date(3000, 0, 1);
+				endDate = new Date(0);
+				
+				tempDataProvider = new ArrayCollection();
+				tempRowDataProvider = new ArrayCollection();
+				var resMap : Object = new Object();
+				for( var i : Number = 0; i < data.length; i++ )
+				{
+					if (!resMap.hasOwnProperty(data[i].unitId))
+					{
+						resMap[data[i].unitId] = new ArrayCollection();
+						tempRowDataProvider.addItem("Unit " + data[i].unitId);
+					}
+					
+					var dummycolor : uint = 0x999999 + randomInt( 0x777777 );
+					
+					resMap[data[i].unitId].addItem(createColoredEntry(data[i].taskId, data[i].begin, data[i].end, dummycolor));
+					
+					if (data[i].begin < startDate) startDate = data[i].begin;
+					if (data[i].end > endDate) endDate = data[i].end;
+				}
+				
+				for (var key : String in resMap)
+				{
+					tempDataProvider.addItem(resMap[key]);
+				}
+				
+				dataProvider = tempDataProvider;
+				rowDataProvider = tempRowDataProvider;
+				
+				scheduleViewer.invalidateDisplayList();
+				this.validateNow();
+				rowsList.verticalScrollPosition = lastPosRowList;
+				rowsList.selectedIndex = listIndex;
+				
 			}
 			
@@ -164,6 +206,4 @@
 				dataProvider = tempDataProvider;
 				rowDataProvider = tempRowDataProvider;
-				
-				Alert.show("finished! " + startDate + " " + endDate);
 			}
 			
@@ -178,6 +218,9 @@
 			/* end of copy */
 			
-			protected function init():void
-			{
+			public function init():void
+			{
+				//scheduleViewer.percentHeight = 100;
+				//scheduleViewer.percentWidth = 100;
+				
 				listIndex = 0;
 				zoom = 500;
@@ -335,5 +378,5 @@
 					<mx:List id="rowsList" width="135" height="{ scheduleViewerHeight }"
 							 dataProvider="{ rowDataProvider }" rowHeight="{ scheduleViewer.rowHeight }"
-							 verticalAlign="middle"
+							 verticalAlign="middle" verticalScrollPolicy="off"
 							 itemClick="rowsList_itemClickHandler(event)" selectable="true">
 						
@@ -380,5 +423,5 @@
 							
 						</s:Group>
-						<s:HGroup width="100%">
+						<s:HGroup width="100%" id="hZoomSliderGroup">
 							<s:Label text="Zoom:" top="5"/>
 							<s:HSlider width="100%" id="zoomSlider" change="onZoom( zoomSlider.value );" liveDragging="true"
@@ -388,5 +431,5 @@
 					
 				</s:VGroup>
-				<s:VGroup width="60" height="100%">
+				<s:VGroup width="60" height="100%" id="vZoomSliderGroup">
 					<mx:Spacer height="{ timeline.height + (scheduleViewer.height - vZoomSlider.height) / 4 }"/>
 					<mx:Label text="V Zoom"/>